package com.gmail.qbradq.bukkit.towny.interop.quickshop;

/*
      This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import org.bukkit.ChatColor;
import org.bukkit.Location;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.plugin.java.JavaPlugin;
import org.maxgamer.QuickShop.Shop.ShopCreateEvent;

import com.palmergames.bukkit.towny.object.TownBlockType;
import com.palmergames.bukkit.towny.object.TownyUniverse;
import com.palmergames.bukkit.towny.object.TownyPermission.ActionType;
import com.palmergames.bukkit.towny.utils.PlayerCacheUtil;

public class InteropMod extends JavaPlugin implements Listener {
	@Override
	public void onEnable() {
		getServer().getPluginManager().registerEvents(this,  this);
	}
	
	@EventHandler
	public void onShopCreateEvent(ShopCreateEvent event) {
		//event.setCancelled(true);
		
		// Check if the player can bypass this check
		if(event.getPlayer().hasPermission("QSPlot.bypass")) {
			return;
		}
		
		Location loc = event.getShop().getLocation();
		
		// Only allow players with build permission on the block to make it a QuickShop
		if(!PlayerCacheUtil.getCachePermission(
				event.getPlayer(),
				loc,
				event.getPlayer().getWorld().getBlockTypeIdAt(loc),
				(byte)0,
				ActionType.BUILD
			)) {
			event.getPlayer().sendMessage(ChatColor.RED + "You do not have permission to build here.");
			event.setCancelled(true);
			return;
		// Only allow QuickShops on commercial Towny plots
		} else if(TownyUniverse.getTownBlock(loc) == null || TownyUniverse.getTownBlock(loc).getType() != TownBlockType.COMMERCIAL) {
			event.getPlayer().sendMessage(ChatColor.RED + "You may only create shops on commercial plots.");
			event.setCancelled(true);
			return;
		}
	}
}
